def scrub(word):
    return word.strip().lower()

def load_word_list(filename):
    word_file = open (filename, 'r')
    word_list = []
    for word in word_file:
        word_list.append( scrub(word) )
    return word_list

def puzzle_a(word_list):
    for word in word_list:
        if (word + 'er')  in word_list and \
           (word + 'est') in word_list:
            print(word, word + 'er', word + 'est')

WORD_FILE_NAME = 'dictionary.txt'

print('Loading word list.')
word_list = load_word_list(WORD_FILE_NAME)
print('Solving puzzle (a).')
puzzle_a(word_list)

# old functions from Session 19

def contains(word, char_list):
    selected_chars = find_all_in(char_list, word)
    return char_list in selected_chars

def find_all_in(desired_chars, word):
    result = ''
    for char in word:
        if char in desired_chars:
            result += char
    return result
